"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidLabelName = exports.markLabelNodeAsErroneous = exports.deriveLabelType = exports.getLabelIdPrefix = void 0;
const object_hash_1 = __importDefault(require("object-hash"));
const types_1 = require("./types");
const getLabelIdPrefix = (vFile) => { var _a; return (0, object_hash_1.default)((_a = vFile.path) !== null && _a !== void 0 ? _a : null).substring(0, 8); };
exports.getLabelIdPrefix = getLabelIdPrefix;
const deriveLabelType = (start, end) => {
    if (start === types_1.LabelFence.START && end === types_1.LabelFence.END) {
        return "single";
    }
    if (start === types_1.LabelFence.START && end === types_1.LabelFence.END_OPENING) {
        return "paired_opening";
    }
    if (start === types_1.LabelFence.START_CLOSING && end === types_1.LabelFence.END) {
        return "paired_closing";
    }
    return "invalid";
};
exports.deriveLabelType = deriveLabelType;
const markLabelNodeAsErroneous = (vFile, labelNode, errorType, errorCaption) => {
    labelNode.data.errorType = errorType;
    labelNode.data.errorCaption = errorCaption;
    vFile.message(errorCaption, labelNode, "litvis:narrative-schema-label");
};
exports.markLabelNodeAsErroneous = markLabelNodeAsErroneous;
const isValidLabelName = (name) => !!name.match(/^[a-zA-Z][a-zA-Z0-9_]*$/);
exports.isValidLabelName = isValidLabelName;
//# sourceMappingURL=utils.js.map